#include <Arduino.h>
#include <WiFi.h>
#include <WebServer.h>
#include <ESP32_Servo.h>

#define LED_PIN 19
#define WIFI_SSID "ACEBOTT"  //set WIFI name
#define WIFI_PASSWORD "12345678" //set WIFI password
#define WINDOW_SERVO_PIN 13
#define DOOR_SERVO_PIN 4
WebServer server(80);
Servo servo_window;
Servo servo_door;
const int window_close=60;
const int window_open=123;
//Window Servo Configuration
const int door_close=5;
const int door_open=100;
//Door Servo Configuration
void handleRoot() {
  server.send(200, "text/plain", "Hello from ESP32 at "+ WiFi.localIP().toString());
}
void test(){
  server.send(200, "text/plain", "Test_OK");
}
void openDoor() {
  servo_door.write(door_open);
  server.send(200, "text/plain", "Open the door");
}
void closeDoor() {
  servo_door.write(door_close);
  server.send(200, "text/plain", "close the door");
}
void openWindow() {
  servo_window.write(window_open);
  server.send(200, "text/plain", "Open the window");
}
void closeWindow() {
  servo_window.write(window_close);
  server.send(200, "text/plain", "close the window");
}






void setup() {
  /***** show IP address in serial monitor ****/
  Serial.begin(115200);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println(".");
  }
  Serial.print("IP:");
  Serial.println(WiFi.localIP());
  server.on("/", handleRoot);
  server.on("/Test", test);
  server.on("/door_on", openDoor);
  server.on("/door_off", closeDoor);
  server.on("/window_on", openWindow);
  server.on("/window_off", closeWindow);
  server.begin();
 //WIFI initialization
   
  servo_door.attach(DOOR_SERVO_PIN,500,2500);
  servo_door.write(door_close);
  delay(500);
  //Initialization of gate servo

  servo_window.attach(WINDOW_SERVO_PIN,500,2500);
  servo_window.write(window_open);
  delay(500);
  //Initialization of window servos 
}

void loop() {
  server.handleClient();
}


